SET (REL_INSTALL_DIR "share/glib-2.0/schemas")
SET (ABS_INSTALL_DIR "${CMAKE_BINARY_DIR}/${REL_INSTALL_DIR}")
CONFIGURE_FILE ("${GSchemaFile}.gschema.xml" "${ABS_INSTALL_DIR}/${GSchemaFile}-${MAJOR}.gschema.xml")
EXECUTE_PROCESS (COMMAND glib-compile-schemas "--targetdir=${ABS_INSTALL_DIR}" "${ABS_INSTALL_DIR}")
INSTALL (FILES "${ABS_INSTALL_DIR}/${GSchemaFile}-${MAJOR}.gschema.xml" DESTINATION "${REL_INSTALL_DIR}")
IF (WIN32)
    INSTALL (FILES "${ABS_INSTALL_DIR}/gschemas.compiled" DESTINATION "${REL_INSTALL_DIR}/${PROJECT_LOWERCASE_NAME}-${MAJOR}")
ENDIF (WIN32)
